def cdist(x1: Tensor,
    x2: Tensor,
    p: float=2.,
    compute_mode: str="use_mm_for_euclid_dist_if_necessary") -> Tensor:
  _0 = "{} is not a valid value for compute_mode"
  _1 = uninitialized(Tensor)
  _2 = torch.eq(compute_mode, "use_mm_for_euclid_dist_if_necessary")
  if _2:
    _3 = torch.cdist(x1, x2, p)
  else:
    _4 = torch.eq(compute_mode, "use_mm_for_euclid_dist")
    if _4:
      _5 = torch.cdist(x1, x2, p, 1)
    else:
      _6 = torch.eq(compute_mode, "donot_use_mm_for_euclid_dist")
      if _6:
        _7 = torch.cdist(x1, x2, p, 2)
      else:
        ops.prim.RaiseException(torch.format(_0, compute_mode))
        _7 = _1
      _5 = _7
    _3 = _5
  return _3
def tensordot(a: Tensor,
    b: Tensor,
    dims: int=2,
    out: Optional[Tensor]=None) -> Tensor:
  _8 = "tensordot expects dims >= 0, but got dims={}"
  dims0 = unchecked_cast(int, dims)
  dims1 = unchecked_cast(int, dims0)
  dims2 = unchecked_cast(int, dims1)
  dims3 = unchecked_cast(int, dims2)
  if torch.lt(dims3, 0):
    ops.prim.RaiseException(torch.format(_8, dims3))
  else:
    pass
  _9 = torch.neg(dims3)
  dims_a = annotate(List[int], [])
  for _10 in range(torch.__range_length(_9, 0, 1)):
    _11 = torch.append(dims_a, torch.__derive_index(_10, _9, 1))
  dims_b = annotate(List[int], [])
  for _12 in range(dims3):
    _13 = torch.append(dims_b, _12)
  if torch.__is__(out, None):
    _15 = torch.tensordot(a, b, dims_a, dims_b)
    _14 = _15
  else:
    out0 = unchecked_cast(Tensor, out)
    _16 = torch.tensordot(a, b, dims_a, dims_b, out=out0)
    _14 = _16
  return _14
